#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## log.pm for  in /home/dayan/intellique/log
## 
## ######### PROJECT DESCRIPTION : ###
## 
## Objet log
## 
## ###################################
## 
## Made by Dayan Romain
## Login   <dayan@intellique.com>
## 
## Started on  Tue May 10 12:38:46 2005 husianycia cedric
## Last update Thu Sep 22 12:31:14 2005 husianycia cedric
## 
## ###################################
##

#####################################
## Declaration de Package

package	Objet_Log;

#####################################
## Declaration de librairie

use	strict;
     	
#####################################
## Fonction de creation de l'objet

sub	new {
    my $objet_name	= shift;
    my $filename	= shift;
    my $isdebug		= shift;
    my $log		= {};
    
    $log->{DEBUG} = undef;
    $log->{OBJNAME} = $objet_name;
    if ($isdebug and ($isdebug eq "DEBUG")) {
	$log->{DEBUG} = "DEBUG";
    }

    _debug($log, "filename pas present\n") and return undef unless ($filename);
    $log->{FILENAME} = $filename;

    
    open(LOG, ">>$log->{FILENAME}") or (_debug($log, "$!") and return undef);
    close(LOG);
    bless($log);
    return $log;
}

#####################################
## Fonction d'ecriture de hash dans le fichier

sub	set_msg {
    my $self		= shift;
    my $ref_hash	= shift;

    # Verification de la reference recue
    if ($ref_hash) {
	unless (ref($ref_hash) eq "HASH") {
	    _debug($self, "set_msg : \\\%hash recu incorrecte\n");
	    return undef;
	}
    }
    else {
	_debug($self, "set_msg : \\\%hash non defini\n");
	return undef;
    }
    
    open (LOG, ">>$self->{FILENAME}") or (_debug($self, "$!") and return undef);
    
    my %copy_hash;

    # Verification de la cle :
    foreach (keys(%{$ref_hash})) {
	if ($_ =~ m/^[0-9\.]*$/) {
	    $copy_hash{$_} = $ref_hash->{$_};
	}
	else{
	    _debug($self, "set_msg : Cle incorrecte ($_): m/^[0-9\\.]*\$\/ \n"); 
	}
    }
    
    #tri de la hash par date et sortie dans le fichier
    
    foreach (sort {$a <=> $b}(keys %copy_hash)) {
	if ($copy_hash{$_}){
	    print LOG $copy_hash{$_}."\n";
	}
	else{
	    _debug($self, "set_msg : Message incorrect (Key : $_)\n");
	}
    }

    close(LOG);

    return (1);
}

#####################################
## Fonction qui ecris les 

sub	set_event_msg {
    my $self		= shift;
    my $tmp_event	= shift;
    my @list_type	= @_;
    my %hash_to_file;
    
    #return undef si on a pas la reference de l'objet event
    if ($tmp_event) {
	unless (ref($tmp_event) eq "Objet_Event") {
	    _debug($self, "set_event_msg : \%event recu incorrect\n");
	    return undef;
	}
    }
    else {
	_debug($self, "set_event_msg : \%event non defini\n");
	return undef;
    }
    
    
    # liste de type mis en parametre
    if (@list_type > 0) {
	foreach (@list_type) {
	    # reception des ref_hash suivant les type demandes
	    if (my $refhash = $tmp_event->get_event($_)) {
		# Suppression des event de type demande
		if ($tmp_event->delete_event($_)) {
		    # Lecture des refhash, verifications et stockage temp
		    # dans %hash_to_file
		    foreach (keys(%{$refhash})) {
			if ($_ =~ m/^[0-9\.]*$/) {
			    if ($refhash->{$_}) {
				$hash_to_file{$_} = $refhash->{$_};
			    }
			    else {
				_debug($self, "set_event_msg : Message incorrect (Key : $_)\n");
			    }
			}
			else{
			    _debug($self, "set_event_msg : Cle incorrecte ($_): m/^[0-9\\.]*\$\/ \n");
			}
		    }
		}
		else {
		    _debug($self, "set_event_msg : type $_ vide\n");
		}
	    }
	    else {
		_debug($self, "set_event_msg : probleme type $_\n");
	    }
	}
    }
    # Demande des types existants
    else {
	my @list = $tmp_event->get_list();
	foreach (@list) {
	    # reception des ref_hash suivant les types existant
	    if (my $refhash = $tmp_event->get_event($_)) {
		# Suppression des event de type en cours
		if ($tmp_event->delete_event($_)) {
		    # Lecture des refhash, verifications et stockage temp
		    # dans %hash_to_file
		    foreach (keys(%{$refhash})) {
			if ($_ =~ m/^[0-9\.]*$/) {
			    if ($refhash->{$_}) {
				$hash_to_file{$_} = $refhash->{$_};
			    }
			    else {
				_debug($self, "set_event_msg : Message incorrect (Key : $_)\n");
			    }
			}
			else{
			    _debug($self, "set_event_msg : Cle incorrecte ($_): m/^[0-9\\.]*\$\/ \n");
			}
		    }
		}
		else {
		    _debug($self, "set_event_msg : type $_ vide\n");
		}
	    }
	    else {
		_debug($self, "set_event_msg : probleme type $_\n");
	    }
	}
    }

    # Stockage de %hash_to_file dans le fichier par ordre date_epoque
    # aucune verification necessaire (toutes effectuees plus haut :))
    #Ouverture du fichier
    open (LOG, ">>$self->{FILENAME}") or (_debug($self, "$!") and return undef);
    
    foreach (sort {$a <=> $b} keys(%hash_to_file)) {
	print LOG $hash_to_file{$_}."\n";
    }
    
    close(LOG);
    return (1);
}

#####################################
## Fonction qui Affiche le debug de l'objet log 

sub _debug {
    my ($self, $msg) = @_;

    my $retmsg = "DEBUG : " . $self->{OBJNAME} . " : " . $msg . "\n";
    print $retmsg if ($self->{DEBUG});
    return 1;
}

1;

=head1 NOM

Objet Configuration - Ecriture des logs

=head1 PROTOTYPAGE

B<new>($fullname);     
                   [1 ou undef]

B<set_msg>(\%msg);                         [1 ou undef]

B<set_event_msg>((Objet)Event, @type);   [1 ou undef]

=head1 DEFINITION

B<new> : Constructeur de l'objet prenant le chemin complet du fichier de log

B<set_msg> : Ecrit dans le fichier le contenu de la hash passe en parametre ordonne par date (la date etant la cle de I<%msg>)

B<set_event_msg> : Ecrit dans le fichier l'ensemble des types de l'objet Event ordonnes par date. Il les effaces ensuite de ce dernier.

=head1 UTILISATION

#Utilisation de l'objet log :
    use Objet_Log;

#Utilisation de l'objet Event :
    use Objet_Event;

#Initialisation de l'objet event :
    my $mon_log = new Objet_Log("/toto/conf.log");

#Log des differents elements de %mesg :
    my %mesg = ("toto" => "titi", "tutu" => "tata");
    $mon_log->set_msg(\%mesg);

#Log de tous les event de type "WARN" et "ERROR" :
    my $event = new Objet_Event();
    $mon_log->set_event_msg($event, "WARN", "ERROR");

=head1 AUTEUR

Dayan Romain

